from .paggf_core import PAGGFCore
from . import paggf_version
from .ui.BM_load_shp_parcel import BMLoadShpParcelDlg
from .composer.bm_pv_generator import BMPVGeneator
from .ui.welcome import WelcomeBMDlg


class PAGGF_BM(PAGGFCore):
    def __init__(self, iface):
        print('Init PAGGF BM')
        super(PAGGF_BM, self).__init__(
            iface, paggf_version.BM, 'BM et immatriculation TD')

        self.welcome_dlg_class = WelcomeBMDlg
        self.enable_paggf_action(
            'load_parcel_from_file', {
                'menu_title': 'Charger fichiers de points de sommets BM (shp, gpx ou csv)',
                'dlg_class': BMLoadShpParcelDlg})

        self.enable_paggf_action(
            'edit_data',
            {
                'menu_title': "Saisir manuellement le contenu d'un PV BM",
                'pg_schema_name': 'gis',
                'pg_table_name': 'parcels_to_valid'
            })

        self.enable_paggf_action(
            'print_pv',
            {
                'menu_title': 'Exportation et Impression PV bornage arpentage',
                'pg_schema_name': 'gis',
                'pg_table_name': 'parcels_to_valid',
                'pv_generator_cls': BMPVGeneator
            }
        )

    def paggf_menu_content(self):
        return [  # DEFINITION DE L'ARBRE DU MENU
            # quand (nom, list) = sous menu
            # quand (nom, nom_action) = un access a une action
            ('Géométrie parcelle BM', [
                self.actions['load_parcel_from_file'],  # Charger fichiers de points de sommets BM (shp, gpx ou csv)
                "Saisir manuellement les coordonnées XY des sommets d'une parcelle BM",
                "Saisir manuellement les objets internes",
                "Editer et valider la géométrie d'une parcelle BM"
            ]),
            ('Attributs parcelle BM', [
                "Charger automatiquement les attributs PV BM",
                self.actions['edit_data']  # Saisir manuellement le contenu d'un PV BM
            ]),
            ('Croquis orienté parcelle BM', [
                "Préparer et valider un croquis orienté de parcelle BM",
                "Exporter un croquis BM en pdf ou image"
            ]),
            ('Ajout des angles et distances dans le PV bornage arpentage'),
            self.actions['print_pv'],  # Exportation et Impression PV bornage arpentage
            ("Paramétrage et maintenance BD BM", [
                "Paramétrage BD et plugin BM",
                "Synchronisation avec BD centrale"
            ])
        ]
